    PROGRAM nag_mat_norm_ex03

      ! Example Program Text for nag_mat_norm
      ! NAG fl90, Release 4. NAG Copyright 2000.

      ! .. Use Statements ..
      USE nag_examples_io, ONLY : nag_std_in, nag_std_out
      USE nag_mat_norm, ONLY : nag_sym_mat_norm, nag_tri_mat_norm
      ! .. Implicit None Statement ..
      IMPLICIT NONE
      ! .. Intrinsic Functions ..
      INTRINSIC KIND
      ! .. Parameters ..
      INTEGER, PARAMETER :: wp = KIND(1.0D0)
      ! .. Local Scalars ..
      INTEGER :: i, n
      CHARACTER (1) :: uplo
      ! .. Local Arrays ..
      COMPLEX (wp), ALLOCATABLE :: a(:,:)
      ! .. Executable Statements ..
      WRITE (nag_std_out,*) 'Example Program Results for nag_mat_norm_ex03'

      READ (nag_std_in,*)          ! Skip heading in data file
      READ (nag_std_in,*) n, uplo

      ALLOCATE (a(n,n))            ! Allocate storage

      SELECT CASE (uplo)
      CASE ('L','l')
        READ (nag_std_in,*) (a(i,:i),i=1,n)
      CASE ('U','u')
        READ (nag_std_in,*) (a(i,i:),i=1,n)
      END SELECT

      WRITE (nag_std_out,*)
      WRITE (nag_std_out,*) 'Norms of the symmetric matrix'
      WRITE (nag_std_out,'(1X,a23,2x,f7.3)') 'One-norm of (A) =', &
       nag_sym_mat_norm(uplo,a)
      WRITE (nag_std_out,'(1X,a23,2x,f7.3)') 'Infinity Norm of (A) =', &
       nag_sym_mat_norm(uplo,a,norm='i')
      WRITE (nag_std_out,'(1X,a23,2x,f7.3)') 'Frobenius Norm of (A) =', &
       nag_sym_mat_norm(uplo,a,norm='f')
      WRITE (nag_std_out,'(1X,a23,2x,f7.3)') 'MAX(ABS(A(i,j))) =', &
       nag_sym_mat_norm(uplo,a,norm='m')

      WRITE (nag_std_out,*)
      WRITE (nag_std_out,*) 'Norms of the triangular matrix'
      WRITE (nag_std_out,'(1X,a23,2x,f7.3)') 'One-norm of (A) =', &
       nag_tri_mat_norm(uplo,a)
      WRITE (nag_std_out,'(1X,a23,2x,f7.3)') 'Infinity Norm of (A) =', &
       nag_tri_mat_norm(uplo,a,norm='i')
      WRITE (nag_std_out,'(1X,a23,2x,f7.3)') 'Frobenius Norm of (A) =', &
       nag_tri_mat_norm(uplo,a,norm='f')
      WRITE (nag_std_out,'(1X,a23,2x,f7.3)') 'MAX(ABS(A(i,j))) =', &
       nag_tri_mat_norm(uplo,a,norm='m')

      DEALLOCATE (a)               ! Deallocate storage

    END PROGRAM nag_mat_norm_ex03
